﻿Imports Microsoft.AspNet.SignalR
Imports System.Threading.Tasks
Imports System.Net.Http
Imports System.Net.Http.Headers
Imports System.Text

Namespace ConvertHTMLtoPDF
	Public Class PDFHub
		Inherits Hub
		Public Sub Send(ByVal userId As String, ByVal message As String)
			Dim name As String = Context.User.Identity.Name
			Dim convertMessage As String = "no message yet"

            'message is the URL to be converted -> www.bing.com
            Task.Run(Async Sub() convertMessage = Await ConvertToPDFWebJobAPIAsync(message)).Wait()

            Clients.All.broadcastMessage(userId, "just converted: " & message & " to a pdf")
			'Clients.Group(name).individualMessage(name, convertMessage);  //if you want to use a Group, uncomment the OnConnected() method and this line
			Clients.Client(Context.ConnectionId).individualMessage(name, convertMessage)
		End Sub

		'public override Task OnConnected()
		'{
		'    Groups.Add(Context.ConnectionId, Context.User.Identity.Name);
		'    return base.OnConnected();
		'}

		Private Shared async Function ConvertToPDFWebJobAPIAsync(ByVal Url As String) As Task(Of String)
			'PDF file is saved in D:\local\temp\jobs\triggered\convertToPDF\*****\
			Try
                Using client = New HttpClient
                    client.BaseAddress = New Uri("https://your-app-name.scm.azurewebsites.net/")
                    client.DefaultRequestHeaders.Accept.Clear()

                    'username and password from Publish Profile, can test via https://your-app-name.scm.azurewebsites.net/basicAuth
                    Dim userName = "<add your userName>"
                    Dim password = "<add your userPWD"

                    Dim encoding = New ASCIIEncoding
                    Dim authHeader = New AuthenticationHeaderValue("Basic", Convert.ToBase64String(encoding.GetBytes(String.Format($"{userName}:{password}"))))
                    client.DefaultRequestHeaders.Authorization = authHeader

                    Dim content = New System.Net.Http.StringContent("")
                    Dim filename As String = Guid.NewGuid.ToString("N").Substring(0, 8) & ".pdf"
                    Dim response As HttpResponseMessage = Await client.PostAsync($"api/triggeredwebjobs/convertToPDF/run?arguments={Url} {filename}", content)

                    If Not response.IsSuccessStatusCode Then
                        Return $"Conversion for {Url} {filename} failed: " & Date.Now.ToString
                    End If

                    Return $"{response.StatusCode.ToString()}: your PDF can be downloaded from here: https://your-storage-account.blob.core.windows.net/you-storage-container/{filename}"
                End Using
            Catch ex As Exception
				Return ex.Message
			End Try


		End Function
	End Class
End Namespace